package cn.iocoder.yudao.module.bpm.framework.flowable.core.behavior.script.impl;

import cn.hutool.core.util.StrUtil;
import cn.iocoder.yudao.framework.common.util.collection.SetUtils;
import cn.iocoder.yudao.framework.common.util.number.NumberUtils;
import cn.iocoder.yudao.module.bpm.dal.mysql.task.BpmProcessInstanceExtMapper;
import cn.iocoder.yudao.module.bpm.enums.definition.BpmTaskRuleScriptEnum;
import cn.iocoder.yudao.module.bpm.framework.flowable.core.behavior.script.BpmTaskAssignScript;
import cn.iocoder.yudao.module.bpm.service.task.BpmProcessInstanceService;
import lombok.extern.slf4j.Slf4j;
import org.flowable.engine.delegate.DelegateExecution;
import org.flowable.engine.runtime.ProcessInstance;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Set;

/**
 * 分配给旧客户经理审批的 Script 实现类
 *
 * @author 捷道源码
 */
@Component
@Slf4j
public class BpmTaskCustomerManagerNotSameScript implements BpmTaskAssignScript {

    @Resource
    @Lazy // 解决循环依赖
    private BpmProcessInstanceService bpmProcessInstanceService;
    @Resource
    private BpmProcessInstanceExtMapper processInstanceExtMapper;

    @Override
    public Set<Long> calculateTaskCandidateUsers(DelegateExecution execution) {
        ProcessInstance processInstance = bpmProcessInstanceService.getProcessInstance(execution.getProcessInstanceId());
//        adminUserApi.g
        Long startUserId = 0L;
//        BpmProcessInstanceExtDO processInstanceExtDO=processInstanceExtMapper.selectByProcessInstanceId(execution.getRootProcessInstanceId());
        String designatedReview = (String) execution.getParent().getVariable("designatedReview");
//        log.info("[calculateTaskCandidateUsers][分配给旧客户经理审批，id:{},getRootProcessInstanceId:{},execution.getProcessInstanceId()：{},业务编号为 {},发起人:{} ,任务名称:{}]",
//                execution.getId(),
//                execution.getRootProcessInstanceId(),
//                execution.getProcessInstanceId(),processInstanceExtDO.getBusinessNo(),
//                processInstance.getStartUserId(),processInstance.getName());
//        JSONObject jsonObject=new JSONObject();
//        jsonObject.put("data",execution);
//        log.info("execution:{}",jsonObject.toJSONString() );
        if (StrUtil.isNotBlank(designatedReview)) {
            startUserId = NumberUtils.parseLong(designatedReview);
        } else {
            startUserId = NumberUtils.parseLong(processInstance.getStartUserId());
        }
        return SetUtils.asSet(startUserId);
    }

    @Override
    public BpmTaskRuleScriptEnum getEnum() {
        return BpmTaskRuleScriptEnum.HNDOVER_OLD_CUSTOMER;
    }

}
